###################################
# PROLOG SECTION
# flip_coins.py
# Experiment with flipping a coin (text-only version)
#
# The program runs a series of experiments that simulate flipping
# a coin and recording how many times we get heads out of 100
# flips. The experiment is done 1000 times.
#
# After the experiments have been run, the program prints out
# some statistics about the results, which include:
#
# * The minimum number of heads that occurred in an experiment
# * The maximum number of heads that occurred in an experiment
# * The average number of heads for all the experiments
#
# Tested with Python 3.7.9 on Windows 10
# Fri July 16, 2021
#
# Copyright ©. All rights reserved. NAF 2021.
#
# Possible future enhancements:
# Unresolved bugs:
###################################

###################################
# ENVIRONMENT SETUP SECTION
# Imports: random
###################################

# import random number routines
from random import *

###################################
# FUNCTION DEFINITION SECTION
# Definitions: none
###################################

###################################
# PROCESSING INITIALIZATION SECTION
###################################

#
# In this program we experiment with flipping a coin and calculate
# some statistics on the results we get.
#

# Set the constant that is the number of experiments to perform
experiments=1000
# Create a list (array) of results for the experiments
results = experiments*[0]

# set the number of coin flips we do in each experiment
flip_count=100

###################################
# PROCESSING SECTION
# Main loop to perform the experiments and record the results.
# Branching code: if/else
# Looping code: for-loop
###################################

# print out what we are about to simulate
print("simulate flipping", flip_count, "coins", experiments, "times")

# Main for-loop to perform the experiments
for i in range(experiments):
    # print out a progress message every 100 experiments
    if i % 100 == 0:
        print("experiment",i)
    # perform an individual coin flipping experiment
    # initialize the count of heads that occur in the experiment
    heads=0
    
    for j in range(flip_count):
        # simulate flipping a coin to get either 1 or 2 (heads or tails)
        # by getting a random integer, either 1(heads) or 2(tails)
        result = randint(1,2)
        # count the head result
        if result == 1:
            heads=heads+1
        
    # store the result of this experiment in the list
    results[i]=heads

##########################################
# CLEANUP, TERMINATION, AND EXIT SECTION
##########################################

#
# calculate and print out the minimum, maximum and average number of heads
#
results_sum=0
# calculate the average number of heads
for i in range(experiments):
    results_sum=results_sum + results[i]

print("experimental results for",experiments,"experiments flipping a coin",flip_count,"times")
print("minimum heads",min(results),",maximum heads",max(results),",average heads",results_sum/float(experiments))

    
