# PROLOG SECTION
# house.py
#
# Draws a house with a roof on it using Python Turtle Graphics.
# The body of the house is a square.
# The roof is an isosceles right triangle.
# The angle of the roof is 90 degrees.
# The center of the house body is 0,0.
#
# Tested with Python 3.7.9 on Windows 10
# Fri July 16, 2021
#
# Copyright ©. All rights reserved. NAF 2021.
#
# Possible future enhancements:
# Unresolved bugs:
###################################

###################################
# ENVIRONMENT SETUP SECTION
# Imports: turtle
###################################

from turtle import *

###################################
# FUNCTION DEFINITION SECTION
# Definitions: none
###################################

# create the drawing window and give it a title
setup(width=500,height=500)
title("This program draws a house")

# create the turtle used to draw the house
myturtle = Turtle()

###################################
# PROCESSING INITIALIZATION SECTION
###################################

# set the length of the side of the house
side = 200
# useful constant, half the length of the side
halfside = side/2
# calculate the length of the roof using the Pythagorean theorem
# (the length of the hypotenuse equals the square root
# of the sum of the squares of the sides)
# square root of (side**2 + side**2)
roof = (halfside**2 + halfside**2)**0.5

# move the turtle to the starting position
# for drawing the house
myturtle.up()
myturtle.goto(halfside,-halfside)
myturtle.down()

###################################
# PROCESSING SECTION
# Loop drawing the sides of the house
# Branching code: none
# Looping code: for-loop
###################################

# draw the sides of the house by drawing a line
# at headings 90, 180, 270 and 360
for angle in range(90,5*90,90):
    myturtle.setheading(angle)
    myturtle.forward(side)

# draw the two parts of the roof
# move to where we start drawing the roof
myturtle.goto(halfside,halfside)
# set heading for drawing the right-hand side of the roof
myturtle.setheading(135)
# draw the right-hand side of the roof
myturtle.forward(roof)
# draw the left-hand side of the roof
myturtle.goto(-halfside,halfside)

#########################################   
# CLEANUP, TERMINATION, AND EXIT SECTION
#########################################

myturtle.hideturtle()
done()
