###################################
# PROLOG SECTION
# Draws the Olympic rings using Turtle Graphics and uses a function.
# This "debug" version shows how to add print statements for debugging
# purposes.
#
# Tested with Python 3.7.9 on Windows 10
# Fri July 16, 2021
#
# Copyright ©. All rights reserved. NAF 2021.
#
# Possible future enhancements:
# Unresolved bugs:
###################################

###################################
# ENVIRONMENT SETUP SECTION
# Imports: turtle
###################################

# import turtle drawing routines
from turtle import *

###################################
# FUNCTION DEFINITION SECTION
# Definitions: draw_ring()
###################################

#
# This function will draw a ring at a specified
# location, color, and radius.
#
def draw_ring(xcoord,ycoord,ring_color,radius,turtle):
    print("Enter draw_ring, x=",xcoord," y=",ycoord," color=",ring_color," radius=",radius)
    # hide movement of the turtle
    turtle.up()
    # move to the ring location
    turtle.goto(xcoord,ycoord)
    # now show the turtle movement
    turtle.down()
    # set the color of the ring
    turtle.color(ring_color)
    # draw the ring
    print("  drawing circle in draw_ring")
    turtle.circle(radius)
    print("Exit draw_ring")

###################################
# PROCESSING INITIALIZATION SECTION
###################################

print("Start the olympic rings program")
# create a title for the drawing window
title("olympic_rings program using a function")
# create a turtle
turtle=Turtle()
# create the drawing window
setup(width=500,height=500,startx=0,starty=50)
# set the pen width
turtle.width(3)
# set the size of the rings
ring_radius=75

###################################
# PROCESSING SECTION
# Draw the five rings by making calls to the draw_ring function.
# Branching code: none
# Looping code: none
###################################


print("Making function calls to draw the rings")
draw_ring(-100,0,"blue",ring_radius,turtle)
draw_ring(0,0,"black",ring_radius,turtle)
draw_ring(100,0,"red",ring_radius,turtle)
draw_ring(-50,-75,"yellow",ring_radius,turtle)
draw_ring(50,-75,"green",ring_radius,turtle)

###################################   
# CLEANUP, TERMINATION, AND EXIT SECTION
###################################

# don't show the turtle after drawing the rings
print("Done drawing the rings, hide the turtle")
turtle.hideturtle()

# wait for a mouse click to close the window
print("Wait for a mouse click to end the program")
exitonclick()
