###################################
# PROLOG SECTION
# no_name1.py
# Program for student analysis (what does it do? how does it work?)
# Tested with Python 3.7.9 on Windows 10
# Fri July 16, 2021
#
# Copyright ©. All rights reserved. NAF 2021.
###################################

###################################
# ENVIRONMENT SETUP SECTION
###################################

from turtle import *

from time import sleep

###################################
# FUNCTION DEFINITION SECTION
###################################

def draw_shape1(shape1, shape1x, shape1y):
    shape1.speed("fast")    
    shape1.up() 
    shape1.goto(shape1x, shape1y + 50)   
    shape1.sety(shape1y - 150)    
    shape1.down()   
    shape1.color("red")    
    shape1.width(2)   
    shape1.begin_fill()    
    shape1.circle(150)    
    shape1.end_fill()
    shape1.up()   
    shape1.sety(shape1y - 100)
    shape1.down()
    shape1.color("blue")
    shape1.begin_fill()
    shape1.circle(100)
    shape1.end_fill()
    shape1.up()
    shape1.sety(shape1y-50)
    shape1.down()
    shape1.color("green")
    shape1.begin_fill()
    shape1.circle(50)
    shape1.end_fill()
    shape1.hideturtle()
    return

def erase_shape1(shape1, shape1x, shape1y):
    sleep(1)    
    shape1.goto(shape1x, shape1y - 150)
    shape1.down()
    shape1.color("white")
    shape1.width(2)
    shape1.begin_fill()
    shape1.circle(150)
    shape1.end_fill()

def move_shape2(shape2, ax, ay, shape2x, shape2y):   
    shape2.goto(ax,ay)
    shape2.setheading(shape2. towards(shape1x, shape1y))
    shape2.showturtle()
    sleep(1)
    steps = 100
    dx = (shape1x - ax) / float(steps)
    dy = (shape1y - ay) / float(steps)
    for x in range(steps):
        ax = ax + dx
        ay = ay + dy
        shape2.goto(ax,ay)       
    return

###################################
# PROCESSING INITIALIZATION SECTION
###################################

setup()
title("no_name1 program")

shape1 = Turtle()
shape1x = 0
shape1y = 0

shape2 = Turtle()
shape2.hideturtle()
shape2.penup()

register_shape("myshape2",((-6,-96),(-6,0),(-18,0),(0,18),(18,0),(6,0),(6,-96),(-6,-96)))
shape2.shape("myshape2")

###################################
# PROCESSING SECTION 
###################################

draw_shape1(shape1,shape1x,shape1y)

ax = -200
ay = 0

move_shape2(shape2, ax, ay, shape1x, shape1y)

erase_shape1(shape1,shape1x,shape1y)

shape1x = 100
shape1y = 100

draw_shape1(shape1,shape1x,shape1y)

move_shape2(shape2, ax, ay, shape1x, shape1y)

###################################   
# CLEANUP, TERMINATION, AND EXIT SECTION
# Note: done() not required by Thonny
###################################

done()

