###################################
# PROLOG SECTION
# no_name2.py
# Program for student analysis (what does it do? how does it work?)
# Tested with Python 3.7.9 on Windows 10
# Fri July 16, 2021
#
# Copyright ©. All rights reserved. NAF 2021.
###################################

###################################
# ENVIRONMENT SETUP SECTION
###################################

from turtle import *

from time import sleep

from random import *

###################################
# FUNCTION DEFINITION SECTION
###################################

def draw_shape(thecolor, shape, x, y):
        shape.up()
        shape.goto(x,y)
        shape.down()
        shape.color(thecolor)
        shape.width(2)
        shape.speed("fastest")
        shape.hideturtle()
        for radius in range(1,220,5):
                angle = radius - 1
                shape.setheading(angle)
                shape.circle(radius)
        sleep(2)
        shape.color("white")
        for radius in range(216,1,-5):
                angle = radius - 1
                shape.setheading(angle)
                shape.circle(radius)      
        
###################################
# PROCESSING INITIALIZATION SECTION
###################################

setup()
title("no_name2 program")

shape=Turtle()

shape_colors = ("red","blue","green","pink","yellow","black","brown","purple")

###################################
# PROCESSING SECTION
###################################

thecolor = choice(shape_colors)
draw_shape(thecolor, shape, 0, 50)

sleep(1)

thecolor = choice(shape_colors)
draw_shape(thecolor, shape, 100, 150)

###################################   
# CLEANUP, TERMINATION, AND EXIT SECTION
# Note: done() not required by Thonny
###################################

done()
